#include <iostream>
#include <string>
#include <strstream>
#include <fstream>
#include <map>
#include <vector>

int main(int argc,char**argv)
{
  if(argc!=3)
    {
      cerr << argv[0] << " txt1 txt2 \n";
      cerr << " Converts plain text into GIZA++ snt-format.\n";
      exit(1);
    }
  ifstream i1(argv[1]),i2(argv[2]);
  string line,word;
  vector<vector<string> > t1,t2;
  map<string,int> v1,v2;
  map<string,int> id1,id2;
  vector<string> iid1(2),iid2(2);
  while(getline(i1,line))
    {
      istrstream ii1(line.c_str());
      t1.push_back(vector<string>());
      while(ii1>>word)
	{
	  t1.back().push_back(word);
	  v1[word]++;
	  if( id1.find(word)==id1.end() )
	    {
	      iid1.push_back(word);
	      id1[word]=iid1.size()-1;
	    }
	}
    } 
  while(getline(i2,line))
    {
      istrstream ii2(line.c_str());
      t2.push_back(vector<string>());
      while(ii2>>word)
	{
	  t2.back().push_back(word);
	  v2[word]++;
	  if( id2.find(word)==id2.end() )
	    {
	      iid2.push_back(word);
	      id2[word]=iid2.size()-1;
	    }
	}
    }
  if( t1.size()!=t2.size() )
    {
      cerr << "ERROR: texts have different length: " << t1.size() << " " << t2.size() << endl;
      exit(1);
    }
  
  string vocab1(argv[1]),vocab2(argv[2]),snt;
  snt=vocab1+vocab2+string(".snt");
  vocab1+=string(".vcb");
  vocab2+=string(".vcb");

  ofstream ovocab1(vocab1.c_str()),ovocab2(vocab2.c_str()),osnt(snt.c_str());
  for(unsigned int i=2;i<iid1.size();++i)
    ovocab1 << i << ' ' << iid1[i] << ' ' << v1[iid1[i]] << '\n';
  for(unsigned int i=2;i<iid2.size();++i)
    ovocab2 << i << ' ' << iid2[i] << ' ' << v2[iid2[i]] << '\n';
  for(unsigned int i=0;i<t1.size();i++)
    {
      osnt << "1\n";
      for(unsigned int j=0;j<t1[i].size();++j)
	osnt << id1[t1[i][j]] << ' ';
      osnt << '\n';
      for(unsigned int j=0;j<t2[i].size();++j)
	osnt << id2[t2[i][j]] << ' ';
      osnt << '\n';
    } 
}
